<template>
    <div class="app-data-view">
    <app-sort-bar
        :sortModel="sortModel"
        :sortField="sortField"
        :sortDir="sortDir"
        entityName="ibizuniproduct"
        @clickSort="(val) => {sortClick(val);}">
    </app-sort-bar>
        <row class="data-view-container" v-if="items.length > 0" :gutter="20" type="flex" justify="start" style="margin:0px;">
            <a v-for="(item,index) in items" :key="index" :href = "item.starturl">
                <i-col  style="min-height: 170px;margin-bottom: 10px;">
                    <el-card shadow="always" :class="[ item.isselected === true ? 'isselected' : false, 'single-card-data' ]" @click.native="handleClick(item)" @dblclick.native="handleDblClick(item)">
                        <div class="data-view-item">
                            <img v-if="item.srficonpath" :src="item.srficonpath" class="single-card-img" />
                            <img v-else src="/assets/img/noimage.png" class="single-card-img" />
                            <div class="single-card-default">
                                <Tooltip :content="item.srfmajortext">
                                {{item.srfmajortext}}
                                </Tooltip>
                            </div>
                        </div>
                        <div class="data-view-item-action">
                            <template v-for="(action,index) in Object.keys(ActionModel)">
                                <button type="info" :key="index" @click="uiAction(item, action, $event)">
                                    <i :class="ActionModel[action].icon" style="margin-right:2px;"></i>
                                    <span>{{ActionModel[action].caption}}</span>
                                </button>
                            </template>
                        </div>
                    </el-card>
                </i-col>
            </a>
        </row>
        <div v-else class="app-data-empty">
        {{ $t('entities.ibizuniproduct.indextype_dataview.nodata') }}
        </div>
        <el-backtop target=".content-container .app-data-view"></el-backtop>
  </div>
</template>
<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model,Inject } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util,ViewTool } from '@/utils';
import NavDataService from '@/service/app/navdata-service';
import AppCenterService from "@service/app/app-center-service";
import IBIZUNIProductService from '@/service/ibizuniproduct/ibizuniproduct-service';
import IndexTypeService from './index-type-dataview-service';
import IBIZUNIProductUIService from '@/uiservice/ibizuniproduct/ibizuniproduct-ui-service';
import CodeListService from "@/codelist/codelist-service";


@Component({
    components: {
      
    }
})
export default class IndexTypeBase extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof IndexTypeBase
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof IndexTypeBase
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof IndexTypeBase
     */
    @Prop() public context!: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof IndexTypeBase
     */
    @Prop() public viewparams!: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof IndexTypeBase
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof IndexTypeBase
     */
    public getControlType(): string {
        return 'DATAVIEW'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof IndexTypeBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {IndexTypeService}
     * @memberof IndexTypeBase
     */
    public service: IndexTypeService = new IndexTypeService({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {IBIZUNIProductService}
     * @memberof IndexTypeBase
     */
    public appEntityService: IBIZUNIProductService = new IBIZUNIProductService({ $store: this.$store });
    


    /**
     * 转化数据
     *
     * @param {any} args
     * @memberof  IndexTypeBase
     */
    public transformData(args: any) {
        let _this: any = this;
        if(_this.service && _this.service.handleRequestData instanceof Function && _this.service.handleRequestData('transform',_this.context,args)){
            return _this.service.handleRequestData('transform',_this.context,args)['data'];
        }
    }

    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof IndexTypeBase
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof IndexTypeBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }



    /**
     * 代码表服务对象
     *
     * @type {CodeListService}
     * @memberof IndexTypeBase
     */  
    public codeListService:CodeListService = new CodeListService({ $store: this.$store });

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof IndexTypeBase
     */
    public getDatas(): any[] {
        return this.selections;
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof IndexTypeBase
     */
    public getData(): any {
        return null;
    }

    /**
     * 是否默认选中第一条数据
     *
     * @type {boolean}
     * @memberof IndexTypeBase
     */
    @Prop({ default: false }) public isSelectFirstDefault!: boolean;

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof IndexTypeBase
     */
    @Prop({ default: true }) public showBusyIndicator?: boolean;

    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof IndexTypeBase
     */
    @Prop() public createAction!: string;

    /**
     * 部件行为--remove
     *
     * @type {string}
     * @memberof IndexTypeBase
     */
    @Prop() public removeAction!: string;

    /**
     * 部件行为--update
     *
     * @type {string}
     * @memberof IndexTypeBase
     */
    @Prop() public updateAction!: string;

    /**
     * 部件行为--fetch
     *
     * @type {string}
     * @memberof IndexTypeBase
     */
    @Prop() public fetchAction!: string;


    /**
     * this引用
     *
     * @type {number}
     * @memberof IndexTypeBase
     */
    public thisRef: any = this;

    /**
     * 拖拽元素对象
     *
     * @type {boolean}
     * @memberof IndexTypeBase
     */
    public dragEle:any;


    /**
     * 拖拽后位置left
     *
     * @type {boolean}
     * @memberof IndexTypeBase
     */
    public leftP:any;

    /**
     * 拖拽后位置top
     *
     * @type {boolean}
     * @memberof IndexTypeBase
     */
    public topP:any;

    /**
     * 拖拽标识
     * 
     * @type {boolean}
     * @memberof IndexTypeBase
     */
    public dragflag:boolean=false;

    /**
     * 为拖拽不是点击
     * 
     * @type {boolean}
     * @memberof IndexTypeBase
     */
    public moveflag:boolean = false;

    /**
     * 是否单选
     *
     * @type {boolean}
     * @memberof IndexTypeBase
     */
    @Prop() public isSingleSelect?: boolean;
    


    /**
     * 数据
     *
     * @type {any[]}
     * @memberof IndexTypeBase
     */
    public items: any[] = [];

    /**
     * 操作栏模型数据
     *
     * @type {*}
     * @memberof IndexTypeBase
     */ 
    public ActionModel:any ={
    };

    /**
     * 是否支持分页
     *
     * @type {boolean}
     * @memberof IndexTypeBase
     */
    public isEnablePagingBar: boolean = false;;

    /**
     * 总条数
     *
     * @type {number}
     * @memberof IndexTypeBase
     */
    public totalRecord: number = 0;

    /**
     * 加载的数据是否附加在items之后
     *
     * @type {boolean}
     * @memberof IndexTypeBase
     */
    public isAddBehind:boolean = false;

    /**
     * 选中数组
     * @type {Array<any>}
     * @memberof IndexTypeBase
     */
    public selections: Array<any> = [];

    /**
     * 当前页
     *
     * @type {number}
     * @memberof IndexTypeBase
     */
    public curPage: number = 1;

    /**
     * 分页条数
     *
     * @type {number}
     * @memberof IndexTypeBase
     */
    public limit: number = 1000;

    /**
     * 排序方向
     *
     * @type {string}
     * @memberof IndexTypeBase
     */    
    public sortDir:string = '';

    /**
     * 排序字段
     *
     * @type {string}
     * @memberof IndexTypeBase
     */    
    public sortField: string = '';

    /**
     * 排序模型数据集
     *
     * @type {string}
     * @memberof IndexTypeBase
     */  
    public sortModel: any[] = [
        'ibizuniproductname',
    ]

    /**
     * 应用状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof IndexTypeBase
     */
    public appStateEvent: Subscription | undefined;

    /**
     * 默认隐藏批量操作工具栏
     *
     * @type {boolean}
     * @memberof IndexTypeBase
     */
    public flag: boolean = false;

    /**
     * 更改批量操作工具栏显示状态
     *
     * @param $event
     * @memberof IndexTypeBase
     */
    public onClick($event: any){
        if(!this.moveflag){
            this.flag = !this.flag;
        } 
        this.moveflag = false;
    }

    /**
     * 排序点击事件
     * @param {string} field 属性名
     *
     * @memberof IndexTypeBase
     */
    public sortClick(field:string) {
        if(this.sortField !== field){
            this.sortField = field;
            this.sortDir = 'asc';
        }else if(this.sortDir === 'asc'){
            this.sortDir = 'desc';
        }else if(this.sortDir === 'desc'){
            this.sortDir = '';
        }else{
            this.sortDir = 'asc';
        }
        this.refresh();
    }

    /**
     * 排序class变更
     * @param {string} field 属性名
     *
     * @memberof IndexTypeBase
     */
    public getsortClass(field:string) {
        if(this.sortField !== field || this.sortDir === ''){
            return '';
        }else if(this.sortDir === 'asc'){
            return 'sort-ascending'
        }else if(this.sortDir === 'desc'){
            return 'sort-descending'
        }
    }

    /**
     * Vue声明周期，组件挂载完毕
     *
     * @memberof IndexTypeBase
     */
    public mounted () {
        this.afterMounted();
    }

    /**
     * 执行mounted后的逻辑
     *
     *  @memberof IndexTypeBase
     */    
    public afterMounted(){
        this.$el.addEventListener('scroll', ()=> {
            let el: any = this.$el.getElementsByClassName('dataview-pagination')[0];
            el.style.top = 40 + this.$el.scrollTop + 'px';
        })
    }



    /**
     * Vue声明周期，组件创建完毕
     *
     * @memberof IndexTypeBase
     */
    public created() {
        this.afterCreated();
        this.$nextTick(()=>{
            this.mouseEvent();
        })
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof IndexTypeBase
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(this.name, tag)) {
                    return;
                }
                if (Object.is(action,'load')) {
                    this.refresh(data)
                }
                if (Object.is(action,'filter')) {
                    this.refresh(data)
                }
            });
        }
        if(AppCenterService && AppCenterService.getMessageCenter()){
            this.appStateEvent = AppCenterService.getMessageCenter().subscribe(({ name, action, data }) =>{
                if(!Object.is(name,"IBIZUNIProduct")){
                    return;
                }
                if(Object.is(action,'appRefresh')){
                    this.refresh([data]);
                }
            })
        }
    }

    /**
     * 鼠标移动+放下
     * 
     * @memberof IndexTypeBase
     */
    public mouseEvent(){
        this.dragEle = document.getElementsByClassName('drag-filed')[0];
        document.onmousemove=(e:any)=>{
            if(this.dragflag){
                this.dragEle.style.left = (e.clientX - this.leftP) + 'px';
                this.dragEle.style.top = (e.clientY - this.topP) + 'px';
                this.moveflag = true;
            }
        }
        document.onmouseup=(e:any)=>{
            this.dragflag = false;
        }
    }

    /**
     * mousedown事件
     * 
     * @param $event
     * @memberof IndexTypeBase
     */
    public down(e:any){
        this.leftP = e.clientX - this.dragEle.offsetLeft;
        this.topP = e.clientY - this.dragEle.offsetTop;
        this.dragflag = true;
    }

    /**
	 * 加载更多
	 *
	 * @memberof IndexTypeBase
	 */
    public loadMore(){
        if(this.totalRecord>this.items.length)
        {
            this.curPage = ++this.curPage;
            this.isAddBehind = true;
            this.load({});
        }
    }

    /**
     * 刷新
     *
     * @param {*} [args={}]
     * @memberof IndexTypeBase
     */
    public refresh(args?: any) {
        this.curPage = 1;
        this.load(args, true);
    }

    /**
     * vue 生命周期
     *
     * @memberof IndexTypeBase
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof IndexTypeBase
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        if(this.appStateEvent){
            this.appStateEvent.unsubscribe();
        }
    }

    /**
     * 表格数据加载
     *
     * @public
     * @param {*} [arg={}]
     * @param {boolean} [isReset=false] 是否重置items
     * @memberof IndexTypeBase
     */
    public load(opt: any = {}, isReset: boolean = false): void {
        if(!this.fetchAction){
            this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: 'IBIZUNIProductIndexPickupDataView' + (this.$t('app.list.notConfig.fetchAction') as string) });
            return;
        }      
        const arg: any = {...opt};
        const page: any = {};
        if (this.isEnablePagingBar) {
            Object.assign(page, { page: this.curPage-1, size: this.limit });
        }
        // 设置排序
        if (!Object.is(this.sortDir, '') && !Object.is(this.sortField, '')) {
          const sort: string = this.sortField+","+this.sortDir;
            Object.assign(page, { sort: sort });
        }
        Object.assign(arg, page);
        const parentdata: any = {};
        this.$emit('beforeload', parentdata);
        Object.assign(arg, parentdata);
        let tempViewParams:any = parentdata.viewparams?parentdata.viewparams:{};
        Object.assign(tempViewParams,JSON.parse(JSON.stringify(this.viewparams)));
        Object.assign(arg,{viewparams:tempViewParams});
        const post: Promise<any> = this.service.search(this.fetchAction,JSON.parse(JSON.stringify(this.context)), arg, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response || response.status !== 200) {
                if (response.errorMessage) {
                    this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: response.errorMessage });
                }
                return;
            }
            const data: any = response.data;
            if(!this.isAddBehind){
                this.items = [];
            }
            if (Object.keys(data).length > 0) {
                let datas = JSON.parse(JSON.stringify(data));
                datas.map((item: any) => {
                    Object.assign(item, { isselected: false });
                });
                this.totalRecord = response.total;
                if(isReset){
                    this.items = datas;
                }else{
                    this.items.push(...datas);
                }
            }
            this.isAddBehind = false;
            this.$emit('load', this.items);
            //在导航视图中，如已有选中数据，则右侧展开已选中数据的视图，如无选中数据则默认选中第一条
            if(this.isSelectFirstDefault){
                if(this.selections && this.selections.length > 0){
                    this.selections.forEach((select: any)=>{
                        const index = this.items.findIndex((item:any) => Object.is(item.srfkey,select.srfkey));
                        if(index != -1){
                            this.handleClick(this.items[index]);
                        }
                    })
                }else{
                    this.handleClick(this.items[0]);
                } 
            }
        }, (response: any) => {
            if (response && response.status === 401) {
                return;
            }
            this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: response.errorMessage });
        });
    }

    /**
     * 删除
     *
     * @param {any[]} datas
     * @returns {Promise<any>}
     * @memberof IndexTypeBase
     */
    public async remove(datas: any[]): Promise<any> {
        if(!this.removeAction){
            this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: 'IBIZUNIProductIndexPickupDataView' + (this.$t('app.gridpage.notConfig.removeAction') as string) });
            return;
        }
        let _datas:any[] = [];
        datas.forEach((record: any, index: number) => {
            if (Object.is(record.srfuf, '0')) {
                this.items.some((val: any, num: number) =>{
                    if(JSON.stringify(val) == JSON.stringify(record)){
                        this.items.splice(num,1);
                        return true;
                    }
                }); 
            }else{
               _datas.push(datas[index]);
            }
        });
        if (_datas.length === 0) {
            return;
        }
        let dataInfo = '';
        _datas.forEach((record: any, index: number) => {
            let srfmajortext = record.srfmajortext;
            if (index < 5) {
                if (!Object.is(dataInfo, '')) {
                    dataInfo += '、';
                }
                dataInfo += srfmajortext;
            } else {
                return false;
            }
        });

        if (_datas.length < 5) {
            dataInfo = dataInfo + ' ' + (this.$t('app.dataView.sum') as string) + _datas.length + (this.$t('app.dataView.data') as string);
        } else {
            dataInfo = dataInfo + '...' + ' ' + (this.$t('app.dataView.sum') as string) + _datas.length + (this.$t('app.dataView.data') as string);
        }

        const removeData = () => {
            let keys: any[] = [];
            _datas.forEach((data: any) => {
                keys.push(data.srfkey);
            });
            let _removeAction = keys.length > 1 ? 'removeBatch' : this.removeAction ;
            const context:any = JSON.parse(JSON.stringify(this.context));
            const post: Promise<any> = this.service.delete(_removeAction,Object.assign(context,{ ibizuniproduct: keys.join(';') }),Object.assign({ ibizuniproduct: keys.join(';') },{viewparams:this.viewparams}), this.showBusyIndicator);
            return new Promise((resolve: any, reject: any) => {
                post.then((response: any) => {
                    if (!response || response.status !== 200) {
                        this.$Notice.error({ title: '', desc: (this.$t('app.commonWords.delDataFail') as string) + ',' + response.info });
                        return;
                    } else {
                        this.$Notice.success({ title: '', desc: (this.$t('app.commonWords.deleteSuccess') as string) });
                    }
                    //删除items中已删除的项
                    _datas.forEach((data: any) => {
                      this.items.some((item:any,index:number)=>{
                            if(Object.is(item.srfkey,data.srfkey)){
                                this.items.splice(index,1);
                                return true;
                            }
                        });
                    });
                    this.$emit('remove', null);
                    this.selections = [];
                    resolve(response);
                }).catch((response: any) => {
                    if (response && response.status === 401) {
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: (this.$t('app.commonWords.sysException') as string) });
                        reject(response);
                        return;
                    }
                    reject(response);
                });
            });
        }

        dataInfo = dataInfo.replace(/[null]/g, '').replace(/[undefined]/g, '').replace(/[ ]/g, '');
        this.$Modal.confirm({
            title: (this.$t('app.commonWords.warning') as string),
            content: (this.$t('app.gridpage.confirmDel') as string) + ' ' + dataInfo + '，' + (this.$t('app.gridpage.notRecoverable') as string),
            onOk: () => {
                removeData();
            },
            onCancel: () => { }
        });
        return removeData;
    }


    /**
     * 保存
     *
     * @param {*} $event
     * @returns {Promise<any>}
     * @memberof IndexTypeBase
     */
    public async save(args: any[], params?: any, $event?: any, xData?: any){
        let _this = this;
        let successItems:any = [];
        let errorItems:any = [];
        let errorMessage:any = [];
        for (const item of _this.items) {
            try {
                if(Object.is(item.rowDataState, 'create')){
                    if(!this.createAction){
                        this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: 'IBIZUNIProductIndexPickupDataView' + (this.$t('app.list.notConfig.createAction') as string) });
                    }else{
                      Object.assign(item,{viewparams:this.viewparams});
                      let response = await this.service.add(this.createAction, JSON.parse(JSON.stringify(this.context)),item, this.showBusyIndicator);
                      successItems.push(JSON.parse(JSON.stringify(response.data)));
                    }
                }else if(Object.is(item.rowDataState, 'update')){
                    if(!this.updateAction){
                        this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: 'IBIZUNIProductIndexPickupDataView' + (this.$t('app.list.notConfig.updateAction') as string) });
                    }else{
                        Object.assign(item,{viewparams:this.viewparams});
                        if(item.ibizuniproduct){
                            Object.assign(this.context,{ibizuniproduct:item.ibizuniproduct});
                        }
                        let response = await this.service.add(this.updateAction,JSON.parse(JSON.stringify(this.context)),item, this.showBusyIndicator);
                        successItems.push(JSON.parse(JSON.stringify(response.data)));
                    }
                }
            } catch (error) {
                errorItems.push(JSON.parse(JSON.stringify(item)));
                errorMessage.push(error);
            }
        }
        this.$emit('save', successItems);
        this.refresh();
        if(errorItems.length === 0){
            this.$Notice.success({ title: '', desc: (this.$t('app.commonWords.saveSuccess') as string) });
        }else{
          errorItems.forEach((item:any,index:number)=>{
            this.$Notice.error({ title: (this.$t('app.commonWords.saveFailed') as string), desc: item.majorentityname + (this.$t('app.commonWords.saveFailed') as string) + '！' });
            console.error(errorMessage[index]);
          });
        }
        return successItems;
    }

    /**
     * 面板数据变化处理事件
     * @param {any} item 当前卡片数据
     * @param {any} $event 面板事件数据
     *
     * @memberof IndexTypeBase
     */
    public onPanelDataChange(item:any,$event:any) {
        Object.assign(item, $event, {rowDataState:'update'});
    }

    /**
     * 选择数据
     * @memberof IndexTypeBase
     *
     */
    public handleClick(args: any) {
        args.isselected = !args.isselected;
        if(this.isSingleSelect) {
            this.items.forEach((item:any) =>{
                if(item.srfkey !== args.srfkey){
                    item.isselected =false;
                }
            })
        }
        this.selectchange();
    }

    /**
     * 双击数据
     * @memberof IndexTypeBase
     *
     */
    public handleDblClick(args: any) {
        this.$emit('rowdblclick', args);
    }

    /**
     * 触发事件
     * @memberof IndexTypeBase
     *
     */
    public selectchange() {
        this.selections = [];
        this.items.map((item: any) => {
            if (item.isselected) {
                this.selections.push(item);
            }
        });
        this.$emit('selectionchange', this.selections);
    }

    /**
     * 操作列界面行为
     *
     * @param {*} data
     * @param {*} tag
     * @param {*} $event
     * @memberof IndexTypeBase
     */
	public uiAction(data: any, tag: any, $event: any) {
        $event.stopPropagation();
    }

}
</script>

<style lang='less'>
@import './index-type-dataview.less';
</style>